=== debian/changelog ===
glmark2 (2014.03+git20150611.fa71af2d-0ubuntu8) hirsute; urgency=medium

  * debian/rules:
  * debian/control:
    - Drop mir variant; this uses mirclient, which is no longer built by Mir. 

 -- Christopher James Halse Rogers <raof@ubuntu.com>  Mon, 04 Jan 2021 08:21:54 +1100

glmark2 (2014.03+git20150611.fa71af2d-0ubuntu7) focal; urgency=medium

  * Build using python2.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 27 Mar 2020 14:43:31 +0100

glmark2 (2014.03+git20150611.fa71af2d-0ubuntu6) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:42:28 +0100

glmark2 (2014.03+git20150611.fa71af2d-0ubuntu5) disco; urgency=medium

  * d/p/c-library-check.patch: Grab patch from upstream Git to fix FTBFS by
    checking C libraries using the C compiler.

 -- Logan Rosen <logan@ubuntu.com>  Thu, 10 Jan 2019 21:14:51 -0500

glmark2 (2014.03+git20150611.fa71af2d-0ubuntu4) yakkety; urgency=medium

  * Switch to libpng-dev from libpng12-dev

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 22 Apr 2016 15:20:23 +0200

glmark2 (2014.03+git20150611.fa71af2d-0ubuntu2) wily; urgency=medium

  * No-change rebuild against latest Mir

 -- Christopher James Halse Rogers <raof@ubuntu.com>  Thu, 02 Jul 2015 15:21:13 +1000

glmark2 (2014.03+git20150611.fa71af2d-0ubuntu1) wily; urgency=medium

  [ Alexandros Frantzis ]
  * Import latest version from upstream git (fa71af2d).
  * debian/control:
    - Build depend on libmirclient-dev >= 0.13.
    - Update Standards-Version to 3.9.6.
  * debian/rules:
    - Build glmark2 without -Werror.

  [ Christopher James Halse Rogers ]
  * debian/control:
  * debian/rules:
    - Drop architecture restrictions on libmirclient build-dep.
      Mir is now built for all architectures.

 -- Christopher James Halse Rogers <raof@ubuntu.com>  Fri, 12 Jun 2015 17:58:39 +1000
