=== debian/control ===
Source: glmark2
Section: misc
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Alexandros Frantzis <alexandros.frantzis@linaro.org>
Build-Depends: debhelper (>= 9),
               python2,
               pkg-config,
               libx11-dev,
               libjpeg-dev,
               libpng-dev,
               libgl1-mesa-dev | libgl1-dev,
               libegl1-mesa-dev | libegl1-x11-dev,
               libgles2-mesa-dev | libgles2-dev,
               libwayland-dev,
               libdrm-dev,
               libgbm-dev,
Standards-Version: 3.9.6
Homepage: https://launchpad.net/glmark2

Package: glmark2
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         glmark2-data (= ${source:Version})
Description: OpenGL 2.0 X11 benchmark
 A benchmark for OpenGL (ES) 2.0 that uses only the OpenGL ES 2.0 compatible
 API. It contains tests for standard OpenGL (ES) 2.0 features, such as vertex
 arrays, VBOs, texturing and shaders.
 .
 This package contains the OpenGL 2.0 variant of the benchmark for X11.

Package: glmark2-es2
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         glmark2-data (= ${source:Version})
Description: OpenGL ES 2.0 X11 benchmark
 A benchmark for OpenGL (ES) 2.0 that uses only the OpenGL ES 2.0 compatible
 API. It contains tests for standard OpenGL (ES) 2.0 features, such as vertex
 arrays, VBOs, texturing and shaders.
 .
 This package contains the OpenGL ES 2.0 variant of the benchmark for X11.

Package: glmark2-wayland
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         glmark2-data (= ${source:Version})
Description: OpenGL 2.0 Wayland benchmark
 A benchmark for OpenGL (ES) 2.0 that uses only the OpenGL ES 2.0 compatible
 API. It contains tests for standard OpenGL (ES) 2.0 features, such as vertex
 arrays, VBOs, texturing and shaders.
 .
 This package contains the OpenGL 2.0 variant of the benchmark for Wayland.

Package: glmark2-es2-wayland
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         glmark2-data (= ${source:Version})
Description: OpenGL ES 2.0 Wayland benchmark
 A benchmark for OpenGL (ES) 2.0 that uses only the OpenGL ES 2.0 compatible
 API. It contains tests for standard OpenGL (ES) 2.0 features, such as vertex
 arrays, VBOs, texturing and shaders.
 .
 This package contains the OpenGL ES 2.0 variant of the benchmark for Wayland.

Package: glmark2-drm
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         glmark2-data (= ${source:Version})
Description: OpenGL 2.0 DRM benchmark
 A benchmark for OpenGL (ES) 2.0 that uses only the OpenGL ES 2.0 compatible
 API. It contains tests for standard OpenGL (ES) 2.0 features, such as vertex
 arrays, VBOs, texturing and shaders.
 .
 This package contains the OpenGL 2.0 variant of the benchmark for DRM.

Package: glmark2-es2-drm
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         glmark2-data (= ${source:Version})
Description: OpenGL ES 2.0 DRM benchmark
 A benchmark for OpenGL (ES) 2.0 that uses only the OpenGL ES 2.0 compatible
 API. It contains tests for standard OpenGL (ES) 2.0 features, such as vertex
 arrays, VBOs, texturing and shaders.
 .
 This package contains the OpenGL ES 2.0 variant of the benchmark for DRM.

Package: glmark2-data
Architecture: all
Depends: ${misc:Depends}
Description: data files for the glmark2 OpenGL (ES) 2.0 benchmark
 A benchmark for OpenGL (ES) 2.0 that uses only the OpenGL ES 2.0 compatible
 API. It contains tests for standard OpenGL (ES) 2.0 features, such as vertex
 arrays, VBOs, texturing and shaders.
 .
 This package contains the data files used by the glmark2 benchmark.
