## glmark2 2017.07

=== wscript ===
--- 
+++ 
@@ -1,14 +1,10 @@
-import commands
-import subprocess
 import os
-import Options
-import Scripting
 from waflib import Context
 
 out = 'build'
 top = '.'
 
-VERSION = '2014.03+git20150611.fa71af2d'
+VERSION = '2017.07'
 APPNAME = 'glmark2'
 
 FLAVORS = {
@@ -36,9 +32,9 @@
     return False
 
 def options(opt):
-    opt.tool_options('gnu_dirs')
-    opt.tool_options('compiler_cc')
-    opt.tool_options('compiler_cxx')
+    opt.load('gnu_dirs')
+    opt.load('compiler_c')
+    opt.load('compiler_cxx')
 
     opt.add_option('--with-flavors', type = 'string', action='callback',
                    callback=option_list_cb,
@@ -50,8 +46,6 @@
                    default = True, help='disable compiler debug information')
     opt.add_option('--no-opt', action='store_false', dest = 'opt',
                    default = True, help='disable compiler optimizations')
-    opt.add_option('--no-werror', action='store_false', dest = 'werror',
-                   default = True, help='disable treating compiler warnings as errors')
     opt.add_option('--data-path', action='store', dest = 'data_path',
                    help='path to main data (also see --data(root)dir)')
     opt.add_option('--extras-path', action='store', dest = 'extras_path',
@@ -59,40 +53,40 @@
 
 def configure(ctx):
     # Special 'all' flavor
-    if 'all' in Options.options.flavors:
-        Options.options.flavors = list(set(Options.options.flavors) | set(FLAVORS.keys()))
-        Options.options.flavors.remove('all')
+    if 'all' in ctx.options.flavors:
+        ctx.options.flavors = list(set(ctx.options.flavors) | set(FLAVORS.keys()))
+        ctx.options.flavors.remove('all')
 
     # Ensure the flavors are valid
-    for flavor in Options.options.flavors:
+    for flavor in ctx.options.flavors:
        if flavor not in FLAVORS:
             ctx.fatal('Unknown flavor: %s. Supported flavors are %s' % (flavor, FLAVORS_STR))
 
-    if not Options.options.flavors:
+    if not ctx.options.flavors:
         ctx.fatal('You need to select at least one flavor. Supported flavors are %s' % FLAVORS_STR)
 
     for flavor in FLAVORS:
-        if flavor in Options.options.flavors:
+        if flavor in ctx.options.flavors:
             ctx.env["FLAVOR_%s" % flavor.upper().replace('-','_')] = FLAVORS[flavor]
 
-    ctx.check_tool('gnu_dirs')
-    ctx.check_tool('compiler_cc')
-    ctx.check_tool('compiler_cxx')
+    ctx.load('gnu_dirs')
+    ctx.load('compiler_c')
+    ctx.load('compiler_cxx')
 
     # Check required headers
     req_headers = ['stdlib.h', 'string.h', 'unistd.h', 'stdint.h', 'stdio.h', 'jpeglib.h']
     for header in req_headers:
-        ctx.check_cxx(header_name = header, auto_add_header_name = True, mandatory = True)
+        ctx.check_cc(header_name = header, auto_add_header_name = True, mandatory = True)
 
     # Check for required libs
     req_libs = [('m', 'm'), ('jpeg', 'jpeg')]
     for (lib, uselib) in req_libs:
-        ctx.check_cxx(lib = lib, uselib_store = uselib)
+        ctx.check_cc(lib = lib, uselib_store = uselib)
 
     # Check required functions
     req_funcs = [('memset', 'string.h', []) ,('sqrt', 'math.h', ['m'])]
     for func, header, uselib in req_funcs:
-        ctx.check_cxx(function_name = func, header_name = header,
+        ctx.check_cc(function_name = func, header_name = header,
                       uselib = uselib, mandatory = True)
 
     # Check for a supported version of libpng
@@ -112,15 +106,16 @@
         ctx.fatal('You need to install a supported version of libpng: ' + str(supp_png_pkgs))
 
     # Check optional packages
-    opt_pkgs = [('x11', 'x11', None, list_contains(Options.options.flavors, 'x11')),
-                ('gl', 'gl', None, list_contains(Options.options.flavors, 'gl$')),
-                ('egl', 'egl', None, list_contains(Options.options.flavors, 'glesv2$')),
-                ('glesv2', 'glesv2', None, list_contains(Options.options.flavors, 'glesv2$')),
-                ('libdrm','drm', None, list_contains(Options.options.flavors, 'drm')),
-                ('gbm','gbm', None, list_contains(Options.options.flavors, 'drm')),
-                ('mirclient','mirclient', '0.13', list_contains(Options.options.flavors, 'mir')),
-                ('wayland-client','wayland-client', None, list_contains(Options.options.flavors, 'wayland')),
-                ('wayland-egl','wayland-egl', None, list_contains(Options.options.flavors, 'wayland'))]
+    opt_pkgs = [('x11', 'x11', None, list_contains(ctx.options.flavors, 'x11')),
+                ('gl', 'gl', None, list_contains(ctx.options.flavors, 'gl$')),
+                ('egl', 'egl', None, list_contains(ctx.options.flavors, 'glesv2$')),
+                ('glesv2', 'glesv2', None, list_contains(ctx.options.flavors, 'glesv2$')),
+                ('libdrm','drm', None, list_contains(ctx.options.flavors, 'drm')),
+                ('gbm','gbm', None, list_contains(ctx.options.flavors, 'drm')),
+                ('libudev', 'udev', None, list_contains(ctx.options.flavors, 'drm')),
+                ('mirclient','mirclient', '0.13', list_contains(ctx.options.flavors, 'mir')),
+                ('wayland-client','wayland-client', None, list_contains(ctx.options.flavors, 'wayland')),
+                ('wayland-egl','wayland-egl', None, list_contains(ctx.options.flavors, 'wayland'))]
     for (pkg, uselib, atleast, mandatory) in opt_pkgs:
         if atleast is None:
             ctx.check_cfg(package = pkg, uselib_store = uselib,
@@ -132,22 +127,20 @@
 
     # Prepend CXX flags so that they can be overriden by the
     # CXXFLAGS environment variable
-    if Options.options.opt:
+    if ctx.options.opt:
         ctx.env.prepend_value('CXXFLAGS', '-O2')
-    if Options.options.debug:
+    if ctx.options.debug:
         ctx.env.prepend_value('CXXFLAGS', '-g')
-    if Options.options.werror:
-        ctx.env.prepend_value('CXXFLAGS', '-Werror')
-    ctx.env.prepend_value('CXXFLAGS', '-Wall -Wextra -Wnon-virtual-dtor'.split(' '))
+    ctx.env.prepend_value('CXXFLAGS', '-std=c++14 -Wall -Wextra -Wnon-virtual-dtor'.split(' '))
 
     ctx.env.HAVE_EXTRAS = False
-    if Options.options.extras_path is not None:
+    if ctx.options.extras_path is not None:
         ctx.env.HAVE_EXTRAS = True
-        ctx.env.append_unique('GLMARK_EXTRAS_PATH', Options.options.extras_path)
-        ctx.env.append_unique('DEFINES', 'GLMARK_EXTRAS_PATH="%s"' % Options.options.extras_path)
-
-    if Options.options.data_path is not None:
-        data_path = Options.options.data_path 
+        ctx.env.append_unique('GLMARK_EXTRAS_PATH', ctx.options.extras_path)
+        ctx.env.append_unique('DEFINES', 'GLMARK_EXTRAS_PATH="%s"' % ctx.options.extras_path)
+
+    if ctx.options.data_path is not None:
+        data_path = ctx.options.data_path 
     else:
         data_path = os.path.join(ctx.env.DATADIR, 'glmark2')
 
@@ -161,8 +154,8 @@
     ctx.msg("Including extras", "Yes" if ctx.env.HAVE_EXTRAS else "No",
             color = 'PINK');
     if ctx.env.HAVE_EXTRAS:
-        ctx.msg("Extras path", Options.options.extras_path, color = 'PINK')
-    ctx.msg("Building flavors", Options.options.flavors)
+        ctx.msg("Extras path", ctx.options.extras_path, color = 'PINK')
+    ctx.msg("Building flavors", ctx.options.flavors)
 
 def build(ctx):
     ctx.recurse('src')
