=== debian/changelog ===
glmark2 (2017.07-1mx15+1) mx; urgency=medium

  * New upstream release; rebuild for MX 15.
  * Don't build against Mir.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 30 Oct 2017 16:13:32 -0700
