=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Alexandros Frantzis <alexandros.frantzis@linaro.org>
 Build-Depends: debhelper (>= 9),
-               python2,
+               python (>= 2.4),
                pkg-config,
                libx11-dev,
                libjpeg-dev,
@@ -13,8 +13,10 @@
                libegl1-mesa-dev | libegl1-x11-dev,
                libgles2-mesa-dev | libgles2-dev,
                libwayland-dev,
+#               libmirclient-dev (>= 0.13),
                libdrm-dev,
                libgbm-dev,
+               libudev-dev
 Standards-Version: 3.9.6
 Homepage: https://launchpad.net/glmark2
