=== debian/rules ===
--- 
+++ 
@@ -1,8 +1,5 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
-
-PATH := $(PATH):$(CURDIR)/debian/bin
-export PATH
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
@@ -12,14 +9,13 @@
 
 DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 
-FLAVORS:=x11-gl,x11-glesv2,wayland-gl,wayland-glesv2
-FLAVORS:=$(FLAVORS),drm-gl,drm-glesv2
+FLAVORS:=x11-gl,x11-glesv2,wayland-gl,wayland-glesv2,drm-gl,drm-glesv2
 
 %:
 	dh $@
 
 override_dh_auto_configure:
-	./waf configure --with-flavors=$(FLAVORS) --prefix=/usr --no-werror
+	./waf configure --with-flavors=$(FLAVORS) --prefix=/usr
 
 override_dh_auto_build:
 	./waf
