## glmark2 2020.04.01

=== debian/changelog ===
glmark2 (2020.04.01-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * rebuild for mstrict-align

 -- root <root@loongson-pc>  Fri, 28 Jan 2022 12:50:49 +0800

glmark2 (2020.04.01-1) unstable; urgency=medium

  * Initial release(Closes: #15716 )

 -- liuhongda <liuhongda@loongson.cn>  Tue, 29 Dec 2020 10:46:42 +0800
