=== debian/control ===
Source: glmark2
Section: graphics
Priority: optional
Maintainer: liuhongda <liuhongda@loongson.cn>
Build-Depends: debhelper (>= 11), python3, libjpeg62-turbo, libc6, libpng16-16, zlib1g, libx11-6, libstdc++6, libgcc1, libjpeg62-turbo-dev, pkg-config, libpng16-16, libpng-dev, libx11-dev, libdrm-dev, libgbm-dev,libudev-dev
Standards-Version: 4.1.3
Vcs-Browser: https://github.com/glmark2/glmark2
Vcs-Git: http://gerritos.loongnix.org:8081/glmark2

Package: glmark2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: It is a benchmark for OpenGL 2.0
 Common graphical assets for Glamrk2 benchmark suite
