=== debian/changelog ===
glmark2 (2021.02-0ubuntu1) impish; urgency=medium

  * New upstream release 2021.02
    https://github.com/glmark2/glmark2/tree/2021.02
  * Build using python3

 -- Soar Huang <soar.huang@canonical.com>  Sat, 22 May 2021 23:30:19 +0800
